﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@
Sub Class_Globals
	Private at As AudioTrack
	Private BufferSize As Int
	Private SampleRate As Int
	Private ChannelConfig As Int
	Private AudioFormat As Int
	Private mInterrupt As Boolean
	Private Pos As Long
	
	Private PlayThread As Thread
	
	Private mCallback As Object
	Private mEventName As String
	Private InFile As RandomAccessFile
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(CallBack As Object, EventName As String) As Boolean
	
	mCallback = CallBack
	mEventName = EventName
	
	PlayThread.Initialise("Playback")
	
	SampleRate=44100
	AudioFormat=at.Af_PCM_16
	ChannelConfig=at.CH_CONF_STEREO
	
	'Get the min buffer size
	BufferSize=at.GetMinBuffersize(SampleRate,ChannelConfig,AudioFormat)
	Log("Playback Buffer Size " & BufferSize)
	'Try to initialize the player
	at.Initialize(at.Stream_Music,SampleRate,ChannelConfig,AudioFormat,BufferSize,at.Mode_Stream)

	Log(at.GetState)
	'Check it initialized
	If at.GetState < 0 Then
		Msgbox("Failed to initialize AudioTrack","Initialize Failed")
		Return False
	End If
	
	Return True
End Sub

Public Sub PlayFrom(DirName As String, FileName As String, StartPos As Int)
	Log("Play From " & StartPos)
	mInterrupt = False
	InFile.Initialize(DirName,FileName,True)
	at.Play
	PlayThread.Start(Me,"PlayDo",Array(StartPos))
End Sub

Public Sub Stop
	at.Stop
End Sub

Public Sub Interrupt
	mInterrupt = True
End Sub

Public Sub Release
	at.Release
End Sub

'Returns the playback position in frames
Public Sub getPlaybackPosition As Long
	Return Pos
End Sub

Public Sub setPlaybackPosition(NewPos As Long)
	Pos = NewPos
End Sub

Public Sub getSkipLength(Seconds As Long) As Long
	Return 2 * Seconds * SampleRate
End Sub

Public Sub IsRunning As Boolean
	Return PlayThread.Running
End Sub

Private Sub PlayDo(StartPos As Long)
	Log("Playing")
	
	at.SetStereoVolume(at.GetMaxVolume,at.GetMaxVolume)
	'File has a wav header we need to ignore
	Pos = StartPos
	Do While Pos < InFile.Size - BufferSize
		'Break into buffersize chunks and write to the AudioTrack
		Dim Dat(BufferSize) As Byte
		InFile.ReadBytes(Dat,0,Dat.Length,Pos)
		at.WriteByte(Dat,0,Dat.Length)
		Pos = Pos + Dat.Length
		If mInterrupt Then Exit
	Loop
	
	If Not(mInterrupt) Then
		'Write the last bit
		Dim Dat(InFile.Size - Pos - BufferSize) As Byte
		InFile.ReadBytes(Dat,0,Dat.Length,Pos)
		at.WriteByte(Dat,0,Dat.Length)
	End If
End Sub
Sub Playback_Ended(endedOK As Boolean,Error As String)
	Log("Playing Finished")
	InFile.Close

	Stop
	If SubExists(mCallback,mEventName & "_Finished") Then CallSub(mCallback,mEventName & "_Finished")
End Sub