﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@
Sub Class_Globals
	Private RecordThread As Thread
	Private OutFile As RandomAccessFile
	Private BufferSize As Int
	Private AR As AudioRecord
	Private mInterrupt As Boolean
	Private Running As Boolean
	Private mCallback As Object
	Private mEventName As String
	
	Dim BufferSize As Int
	Dim SampleRate As Int
	Dim ChannelConfig As Int
	Dim AudioFormat As Int
	Dim AudioSource As Int
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Callback As Object,EventName As String) As Boolean
	'Initialize the thread to record on
	mCallback = Callback
	mEventName = EventName
	RecordThread.Initialise("Recording")
	
	'Set up recording parameters Not all parameters will be supported on all
	'devices
	AudioSource = AR.A_Src_Mic
	SampleRate = 44100
	ChannelConfig = AR.CH_CONF_STEREO
	AudioFormat = AR.Af_PCM_16
	
	'Determine the required min buffer size
	BufferSize=AR.GetMinBufferSize(SampleRate,ChannelConfig,AudioFormat)
	If BufferSize < 0 Then
		Msgbox("Buffer error, Hardware does not support recording with the given parameters","Buffer error")
		Return False
	End If
	
	Try
		AR.Initialize(AudioSource,SampleRate,ChannelConfig,AudioFormat,BufferSize)
	Catch
		Log(LastException)
		Return False
	End Try

	Return True
End Sub

Public Sub Start(DirName As String, FileName As String,StartPos As Long)
	OutFile.Initialize(DirName,FileName,False)
	OutFile.CurrentPosition = StartPos
	mInterrupt = False
	AR.StartRecording
	'Start the thread to record on
	RecordThread.Start(Me,"RecordDo",Null)
End Sub

Public Sub getCurrentPosition As Long
	Return OutFile.Size
End Sub

Public Sub IsReady As Boolean
	Return AR.GetState = 1
End Sub

Public Sub Stop
	AR.Stop
End Sub

Public Sub Release
	AR.release
End Sub

Public Sub IsRunning As Boolean
	Return RecordThread.Running
End Sub

Public Sub Interrupt
	Log("Recording Interrupt")
	mInterrupt = True
End Sub

Sub RecordDo
	
	Log("Recording...")
	'Do the recording
	'I've read that the read methods are blocking and won't return until
	' the buffer is full.  Which appears to be the case in my testing.
	' data has to be read pretty much immediately or it will get overwritten
	Dim RecData() As Byte
	Do While True
		RecData = AR.ReadBytes(0,BufferSize)
		OutFile.WriteBytes(RecData,0,RecData.Length,OutFile.CurrentPosition)
		'Check if interupt requested
		If mInterrupt Then 
			Exit
		End If
	Loop

End Sub

Sub Recording_Ended(endedOK As Boolean,Error As String)
	Log("Recording Finished " & endedOK)
	Log(Error)
	Log("Recorded File Size " & OutFile.Size)
	Stop
	OutFile.Close

	If SubExists(mCallback,mEventName & "_Finished") Then CallSub(mCallback,mEventName & "_Finished")
	
End Sub